/**
 * Create by sxd
 * date 2018-04-11
 * Description:
 */
var boxContent = function(style) {
  this.top =  (style && style.top) || '10';
  this.left = (style && style.left) || '10';
  this.width = (style && style.width) || '310';
  this.height = (style && style.height) || '50';
  this.isEditor = false;

  this.ox = 0;
  this.oy = 0;

  //组件id名称
  this.domId = ('syq_box_' + Math.random()).replace('.','_');
  //一个实例化的dom
  this.vdom = null;
  //组件当中的所有html
  this.editorContent = null;

  this.drag = false;
  this.smove = false;
  this.nmove = false;
  this.wmove = false;
  this.emove = false;
  this.nwmove = false;
  this.swmove = false;
  this.semove = false;

};

boxContent.prototype.boxTpl = '<div class="line-n line resizable"><div class="circle"></div></div><div class="line-e line resizable"><div class="circle"></div></div><div class="line-s line resizable"><div class="circle"></div></div><div class="line-w line resizable"><div class="circle"></div></div><div class="circle-nw circle resizable"></div><div class="circle-ne circle resizable"></div><div class="circle-se circle resizable"></div><div class="circle-sw circle resizable"></div>';


//由数据渲染层dom
boxContent.prototype.renderToDom = function() {
  this.vdom = $('<div class="outer-box" id="' + this.domId +'"></div>');
  this.vdom.css({ width: this.width, 'min-height': this.height,top: this.top, left: this.left });
  this.renderBoxDom();
};

//组件渲染
boxContent.prototype.renderBoxDom = function() {
  let editorDom = $('<div class="element comp_paragraph editable-text" contenteditable="true"></div>');
  let circleDom = $('<div class="eqc-select"></div>');
  editorDom.text('双击此处进行编辑');
  if(this.editorContent)editorDom.html(this.editorContent);
  editorDom.css({ 'pointer-events': this.isEditor ? 'all' : 'none' });
  circleDom.append(this.boxTpl);
  this.vdom.append(editorDom);
  this.vdom.append(circleDom);

  this.bindDragEvent(this.vdom);
  //这个是双击事件
  this.bindEditorEvent(this.vdom);
  //以下是各个方向的
  this.bindMoveSEvent(this.vdom);
  this.bindMoveEEvent();
  this.bindMoveNEvent(this.vdom);
  this.bindMoveWEvent(this.vdom);

  //东南西北的朝向
  this.bindMoveNWEvent(this.vdom);
  this.bindMoveSWEvent(this.vdom);
  this.bindMoveSEEvent(this.vdom);
};

//拖动属性
boxContent.prototype.bindDragEvent = function (el) {
  let _this = this;
  el.on('mousedown' , function(e) {
    console.log(123);
    let $this = $(this);
    _this.ox = e.pageX;//原始x位置
    _this.oy = e.pageY;
    _this.top = parseInt($this.css('top').replace('px', ''));
    _this.left = parseInt($this.css('left').replace('px', ''));
    _this.drag = true;
    el.on('mousemove', function (e) {
      if(_this.drag){
        let x = e.pageX - _this.ox;
        let y = e.pageY - _this.oy;
        $(this).css({
          left: _this.left + x,
          top: _this.top + y,
          opacity: .5
        });
      }
    }).on('mouseup',function(e){
      _this.drag = false;
      $(this).css('opacity',1);
    });
  });

};

// 朝东方向
boxContent.prototype.bindMoveEEvent = function () {
  let _this = this;
  this.vdom.on('mousedown','.line-e', function(e){
    e.stopPropagation();
    _this.ox = e.pageX;//原始x位置
    _this.width = _this.vdom.width();
    _this.emove = true;
    $(document).on('mousemove', function(e){
      if(_this.emove){
        let x = (e.pageX - parseInt(_this.ox));
        _this.vdom.css({
          width: parseInt(_this.width) + x,
        }).find('.editable-text').css({
          width: parseInt(_this.width) + x
        })
      }
    })
      .on('mouseup', function(){
        _this.emove = false;
        $(document).off('mousemove');
      });
  });
};

//朝南方向拖拽
boxContent.prototype.bindMoveSEvent = function(el) {
  let _this = this;
  el.on('mousedown','.line-s', function(e){
    e.stopPropagation();
    _this.oy = e.pageY;//原始x位置
    _this.height = el.height();
    _this.smove = true;
    $(document).on('mousemove', function(e){
      if(_this.smove){
        let y = (e.pageY - parseInt(_this.oy));
        _this.vdom.css({
          height: parseInt(_this.height) + y
        }).find('.editable-text').css({
          height: parseInt(_this.height) + y
        })
      }
    })
      .on('mouseup', function(){
      _this.smove = false;
      $(document).off('mousemove');
    });
  });
};

//朝北方向
boxContent.prototype.bindMoveNEvent = function(el) {
  let _this = this;
  el.on('mousedown','.line-n', function(e){
    e.stopPropagation();
    console.log(123);
    _this.oy = e.pageY;//原始x位置
    _this.height = el.height();
    _this.top = parseInt(_this.vdom.css('top').replace('px', ''));
    _this.nmove = true;
    $(document).on('mousemove', function(e){
      if(_this.nmove){
        let y = (e.pageY - parseInt(_this.oy));
        _this.vdom.css({
          height: _this.height - y,
          top: _this.top + y
        }).find('.editable-text').css({
          height: _this.height - y
        })
      }
    })
      .on('mouseup', function(){
        _this.nmove = false;
        $(document).off('mousemove');
      });
  });
};

//朝西方向
boxContent.prototype.bindMoveWEvent = function(el) {
  let _this = this;
  el.on('mousedown','.line-w', function(e){
    e.stopPropagation();
    _this.ox = e.pageX;//原始x位置
    _this.width = el.width();
    _this.wmove = true;
    _this.left = parseInt(_this.vdom.css('left').replace('px', ''));
    $(document).on('mousemove', function(e){
      if(_this.wmove){
        let x = (e.pageX - parseInt(_this.ox));
        _this.vdom.css({
          width: _this.width - x,
          left: _this.left + x
        }).find('.editable-text').css({
          width: _this.width - x
        })
      }
    })
      .on('mouseup', function(){
        _this.wmove = false;
        $(document).off('mousemove');
      });
  });
};

// 朝西北
boxContent.prototype.bindMoveNWEvent = function (el) {
  let _this = this;
  el.on('mousedown','.circle-nw',function(e){
    e.stopPropagation();
    _this.ox = e.pageX;//原始x位置
    _this.oy = e.pageY;
    _this.width = el.width();
    _this.height = el.height();
    _this.top = parseInt(_this.vdom.css('top').replace('px', ''));
    _this.left = parseInt(_this.vdom.css('left').replace('px', ''));
    _this.nwmove = true;

    $(document).on('mousemove', function(e){
      if(_this.nwmove){
        let x = e.pageX - _this.ox;
        let y = e.pageY - _this.oy;
        _this.vdom.css({
          height: _this.height - y,
          top: _this.top + y,
          width: _this.width - x,
          left: _this.left + x
        }).find('.editable-text').css({
          height: _this.height - y,
          width: _this.width - x,
        });
      }
    })
      .on('mouseup', function(){
        _this.nwmove = false;
        $(document).off('mousemove');
      });
  });
};

// 朝西南
boxContent.prototype.bindMoveSWEvent = function (el) {
  let _this = this;
  el.on('mousedown','.circle-sw',function(e){
    e.stopPropagation();
    _this.ox = e.pageX;//原始x位置
    _this.oy = e.pageY;
    _this.width = _this.vdom.width();
    _this.height = _this.vdom.height();
    _this.left = parseInt(_this.vdom.css('left').replace('px', ''));
    _this.swmove = true;

    $(document).on('mousemove', function(e){
      if(_this.swmove){
        let x = e.pageX - _this.ox;
        let y = e.pageY - _this.oy;
        _this.vdom.css({
          height: _this.height + y,
          width: _this.width - x,
          left: _this.left + x
        }).find('.editable-text').css({
          height: _this.height + y,
          width: _this.width - x,
        });
      }
    })
      .on('mouseup', function(){
        _this.swmove = false;
        $(document).off('mousemove');
      });
  });
};

//朝东南
boxContent.prototype.bindMoveSEEvent = function (el){
  let _this = this;
  el.on('mousedown','.circle-se',function(e){
    e.stopPropagation();
    _this.ox = e.pageX;//原始x位置
    _this.oy = e.pageY;
    _this.width = el.width();
    _this.height = el.height();
    _this.semove = true;

    $(document).on('mousemove', function(e){
      if(_this.semove){
        let x = e.pageX - _this.ox;
        let y = e.pageY - _this.oy;

        _this.vdom.css({
          height: _this.height + y,
          width: _this.width + x,
        }).find('.editable-text').css({
          height: _this.height + y,
          width: _this.width + x,
        });
      }
    })
      .on('mouseup', function(){
        _this.semove = false;
        $(document).off('mousemove');
      });
  });
};


boxContent.prototype.bindEditorEvent = function(el) {
  el.on('dblclick', function(e) {
    let child = e.target.children[0] || e.target;
    $(this).find('.comp_paragraph').css('pointer-events','all').select();
    let range = window.getSelection();// 创建range
    range.selectAllChildren(child);// range 选择obj下所有子内容
  });

  this.vdom.find('.comp_paragraph').on('blur',function(){
    $(this).css('pointer-events','none');
  });

};


export default boxContent;